# 前言  

在我们开启学习之旅前，先告诉各位一个事实：机器不会学习。一个典型的“学习机”所做的就是找到一个数学模型，当它应用于一组输入(称为“训练数据”)时，就会产生所期望的输出。该数学模型还为大多数其他输入(不同于训练数据)生成正确的输出，条件是这些输入与训练数据具有相同或相似的统计分布。 

为什么说机器不会学习呢？原因是如果你稍微改变输入，输出很可能会完全错误。这不是动物学习的方式。如果你通过直视屏幕来学习玩电子游戏，那么如果有人稍微旋转屏幕，你仍然是一个很好的玩家。机器学习算法，如果是通过“直视”屏幕来训练的，除非它也接受了识别旋转的训练，否则它将无法在旋转的屏幕上玩游戏。 

	
那么为什么叫“机器学习”呢？原因通常是市场营销：阿瑟·塞缪尔(Arthur Samuel)是美国计算机游戏和人工智能领域的先驱，1959年在IBM工作时创造了这个词。类似于在2010年代，IBM试图将“认知计算”一词推向市场，以从竞争中脱颖而出。上世纪60年代，IBM使用了新的酷词“机器学习”来吸引客户和有天赋才华的员工。  

如你所见，就像人工智能不是智能，机器学习不是学习。然而，机器学习是一个普遍认可的术语，通常指的是构建科学和工程的机器，这些机器可以做各种有用的事情，而这些事情通常不能被明确地编程来完成。因此，术语中的“学习”一词是类比动物的学习来使用的，而不是字面上的意思。

## 本书适合哪些读者？  

这本书只包含了自20世纪60年代以来发展起来的大量机器学习材料中的一些部分，这些部分已被证明具有重要的实用价值。机器学习初学者会在这本书中发现足够的细节，以获得一个合适的水平了解该领域，并开始着手思考询问正确的问题。   

有经验的从业者可以用这本书作为进一步自我完善的指导。在项目开始时，当你试图回答一个给定的技术或商业问题是否“机器可学”的问题时，这本书也会派上用场，如果是的话，你应该尝试解决哪些技术问题。  

## 如何使用本书  

如果你要开始学习机器，你应该从头到尾读这本书(只有一百页，没什么困难。)。如果您对书中涉及的特定主题感兴趣，并且希望了解更多信息，大多数部分内容都有一个[QR码](http://themlbook.com)。    

通过使用手机扫描其中一个QR码，您将获得这本书wiki theMLbook.com上的页面链接，并提供附加材料：推荐阅读、视频、Q&A,代码片段、教程和其他奖金。这本书的维基是作者本人，以及来自世界各地的志愿者不断更新的贡献。所以这本书，就像一瓶好酒，购买之后就会变得更好。  

 ![](https://i.imgur.com/pTlv0J1.png)     


使用手机扫描QR码以获取图书维基。  

有些部分没有QR码，但他们很可能也有维基页面。 您可以通过使用wiki的搜索引擎搜索该部分的标题来找到它。

## 我应该买本书吗？ 

本书是秉承“先读后买”的原则发行的。我坚信，在使用，消费之前为内容付费，就是在瞎特么买东西！譬如在你买车之前，你可以在经销商里查看并试用一辆汽车。你可以在百货公司试穿衬衫或连衣裙。所以你必须能够先阅读一本书，然后再付钱。这是本书坚持的理念。    

“先读后买”原则意味着你可以自由下载这本书，阅读它并与你的朋友和同事分享。只有当你阅读和喜欢这本书，或者发现它在任何方面都是有帮助或有用的时候，你才需要买它。   
 
现在你们都准备好了。好好读吧！


  
