# Chapter 2 **符号和定义** 

## 2.1符号  

让我们从重温在学校都学过的数学符号开始，但有些内容可能在毕业晚会一结束就忘了。  

### 2.1.1 数据结构 

标量是一个简单的数值，如15或−3.25。采用标量值的变量或常量用斜体字母表示，如*x*或*a*。  

向量是标量值的有序列表，称为属性。我们将向量表示为粗体字符，例如**x**或**w**。向量可以可视化为指向多维空间中某些方向和点的箭头。图2.1给出了三个二维向量**a**=[2，3]，**b**=[−2，5]和**c**=[1，0]的例子。我们将向量的属性表示为带有索引的斜体值，例如：*w*<sup>(j)</sup>或*x*<sup>(j)</sup>。索引*j*表示向量的特定维度，即属性在列表中的位置。例如，在图2.1中以红色表示的向量a中，*a*<sup>(1)</sup>=2，*a*<sup>(2)</sup>。  

符号*x*<sup>(j)</sup>不要与幂运算符混淆，如*x*<sup>2</sup>(平方）或*x*<sup>3</sup>（立方）。如果我们要将幂运算符（例如square）应用于向量，我们这样写：（*x*<sup>(j)</sup>）2。    

一个变量可以有两个或两个以上的索引，如：*x*<sub>i<sup>(j)或类似于*x*<sub>i,j<sup>(k)。 例如，在神经网络中，我们表示为*x*<sub>l,u<sup>(j)表示l层,u单元的输入特征j。  

**矩阵**是排列成行和列的数字的矩形数组。下面是一个有两行三(英文版写的是两行两列，但例子是两行三列)列的矩阵的例子，矩阵用粗体大写字母表示，例如**A**或**W**。  

$$
 \begin{bmatrix}
   2 & 4 & -3 \\
   31 & -6 & 1
  \end{bmatrix} \tag{4}
$$


集合是唯一元素的无序集合。我们用大写书法体字母表示一个集合。比如，***S***。集合里面的数字可以是有限的(包括一个固定的数量值)。在本节中，我们使用连谱号来表示集合，比如{1, 3, 18, 23, 235} 或者{x1, x2, x3, x4, . . . , xn}。一个集合可以是无限的，并且在某个区间包含所有的值。如果一个集合包含a，b之间所有的值，也包括a,b的值，那么可以用方括号表示为[a,b]。如果集合不包含a,b的值，这样的集合可以用圆括号表示为(a,b)。举个栗子，集合[0,1]包含诸如0,0.0001,0.25，0.784,0.9995和1这样的值。特殊集合***R***包含从负无穷到正无穷所有的数。  

当元素*x*属于集合***S***时，我们记作*x*$\in$***S***，我们能从***S<sub>1***和***S<sub>2***两集合的相交的部分，得到一个新集合***S<sub>3***。在这种情况下，我们写作***S<sub>3*** ***S<sub>1*** ***S<sub>2***。比如，{1,3,5,8}交{1,8,4}得到新集合{1,8}。  

我们能从***S<sub>1***和***S<sub>2***两集合的联合，得到一个新集合***S<sub>3***。在这种情况下，我们写作***S<sub>3*** ***S<sub>1*** ***S<sub>2***。比如，{1,3,5,8}并{1,8,4}得到新集合{1,3,4,5,8}。    

### 2.1.2 大写Sigma符号
